#ifndef __ORDRED_CUTS__
#define __ORDRED_CUTS__

#include "gomory_hu.h"

struct OrderedCuts
{
	struct Node
	{
		int		parent;
		GH_REAL	cost;
	};

	OrderedCuts(GH_REAL _INFTY, GomoryHuOptions* options, ReusableBuffer* common_rbuf);
	~OrderedCuts();

	// nodes: of size input->n
	void Solve(TmpGraph<GH_REAL>* input, GH_REAL* unaries, int L, int* list, Node* nodes, int s_weight=1);
	void SolveParametric(TmpGraph<GH_REAL>* input, GH_REAL* unaries, int L, int* list, Node* nodes, int s_weight=1, GH_REAL* REAL_buf=NULL);



//private:

	OrderedCuts(OrderedCuts* parent);

	int depth;
	ReusableBuffer* common_rbuf;
	Buffer* maxflow_buf;
	ReusableBuffer* maxflow_rbuf;
	ReusableBuffer local_rbuf1, local_rbuf2;
	OrderedCuts* parent;
	OrderedCuts* child;
	GomoryHuOptions* options;
	GH_REAL INFTY;
};


#endif
